scriptName format ["%1Scripts\Client\Functions\Client_BuyUnit.sqf",BIS_WFdPath];
//Last modified 12/17/9 - further modified by Dimitri_Harkov
//*****************************************************************************************
//Description: Buys a unit.
//*****************************************************************************************

Private["_cost","_empty","_factory","_factoryName","_side","_team","_time","_type","_unit","_unitType","_vehicle","_temp_var","_temp_id"];

_type = _this Select 0;
_unitType = _this Select 1;
_factory = _this Select 2;
_empty = _this Select 3;

_team = Group player;
if (Count _this > 4) then {_team = _this Select 4};

_factoryName = "";
if (Call Compile Format["_type == %1AIRPORTTYPE",sideJoinedText]) then {_factoryName = "WingedAircraft"};
if (Call Compile Format["_type == %1DEPOTTYPE",sideJoinedText]) then {_factoryName = "Depot"};
if (_factory isKindOf "locationlogicDepot") then {_factoryName = "Depot"};

if (_factoryName == "") then {_factoryName = Call Compile Format["%1Structures Select _type",sideJoinedText]};

_unit = Call Compile Format["%1%2Units Select _unitType",sideJoinedText,_factoryName];
_cost = Call Compile Format["%1%2Costs Select _unitType",sideJoinedText,_factoryName];
if (!_empty) then {_cost = Call Compile Format["%1%2MannedCosts Select _unitType",sideJoinedText,_factoryName]};

if (_cost > (Call BIS_WF_GetPlayerFunds)) ExitWith {_factory SetVariable["inUse",0,true]};

_time = Call Compile Format["%1%2Times Select _unitType",sideJoinedText,_factoryName];

//If buying a manned vehicle will make team bigger than allowed size then exit now.
if (!_empty && (([_unit,sideJoined] Call BIS_WF_GetCrewAmount) + Count (Units _team Call GetLiveUnits)) > (BIS_WF_Constants GetVariable "MAXPLAYERTEAMSIZE")) ExitWith {_factory SetVariable["inUse",0,true]};

(-_cost) Call BIS_WF_ChangePlayerFunds;

_factory SetVariable["inUseType",_unitType,true];
//_factory SetVariable["inUse",time,true];
Sleep _time;
_factory SetVariable["inUse",0,true];

if (IsNull _factory) ExitWith {};
if (GetDammage _factory >= 1) ExitWith {};

if (Local Leader _team) then
{
	Private["_commander","_crewName","_data","_driver","_factoryPosition","_gunner","_pilotName","_position","_soldier","_soldierName"];

	_position = [GetPos _factory,45,GetDir _factory + 180] Call GetPositionFrom;

	//Query mission config for defined structure types.
	_data = [sideJoined,_factoryName] Call BIS_WF_GetBaseStructureData;
	if (Count _data > 1) then
	{
		_position = [GetPos _factory,_data Select 3,GetDir _factory + (_data Select 4)] Call GetPositionFrom;
		_position = [[_position,0,8] Call GetRandomPosition,15] Call BIS_WF_GetSafePosition;
	}
	else
	{
		if (_factoryName == "Depot") then
		{
			_position = [GetPos _factory,15,GetDir _factory + 270] Call GetPositionFrom;
			_position = [_position,5,6] Call BIS_WF_GetSafePosition;
		};
	};

	if (!(_unit Call BIS_WF_IsSoldier)) then
	{
		_vehicle = _unit CreateVehicle _position;
		[_vehicle,sideJoined] Call BIS_WF_InitUnit;
		_team AddVehicle _vehicle;


		//add radio action

		if (DIH_RADIO_auto_add_on) THEN
		{
			{
				if (((typeOf _vehicle) isKindOf _x)) THEN
				{
					_temp_var = _vehicle getVariable "DIH_RADIO_present";
					if (isNil ("_temp_var")) THEN {_vehicle setVariable ["DIH_RADIO_present", 0, true];};
					if ((_vehicle getVariable "DIH_RADIO_present") == 0) THEN
					{
						_temp_id = _vehicle addAction ["Use Radio", "DIH_radio\DIH_RADIO_action.sqf",[],-9,false,true,"",""];
						_vehicle setVariable ["DIH_RADIO_present", 1, true];
					};
				};
			} forEach DIH_RADIO_auto_add_white;

			//--- check blacklist

			{
				if (((typeOf _vehicle) isKindOf _x)) THEN
				{
					_temp_var = _vehicle getVariable "DIH_RADIO_present";
					if (isNil ("_temp_var")) exitWith {};
					if ((_vehicle getVariable "DIH_RADIO_present") == 1) THEN
					{
						_vehicle removeAction _temp_id;
						_vehicle setVariable ["DIH_RADIO_present", 0, true];
					};
				};
			} forEach DIH_RADIO_auto_add_black;
		};

		_factoryPosition = GetPos _factory;
		_vehicle SetDir -((((_position Select 1) - (_factoryPosition Select 1)) atan2 ((_position Select 0) - (_factoryPosition Select 0))) - 90);

		//Conform to terrain.
		_vehicle SetVelocity [0,0,-1];

		BIS_WF_OwnedVehicles = BIS_WF_OwnedVehicles - [ObjNull];
		BIS_WF_OwnedVehicles = BIS_WF_OwnedVehicles + [_vehicle];

		if (_unit == Call Compile Format["%1SALVAGETRUCK",sideJoinedShortText]) then
		{
			_vehicle SetVariable["autoSalvage",false];
			_vehicle AddAction[Format["%1: %2",Localize "STRWFSALVAGE",Localize "STRWFNO"],corePath + "Client\Action\Action_ToggleSalvageTruck.sqf"];
			[_vehicle] Spawn BIS_WF_UpdateAutoSalvageTruck;
		};

		player Reveal _vehicle;

		//If empty create marker & monitor to remove it.
		if (_empty) ExitWith
		{
			Private["_index"];
			_vehicle SetVariable["clearMarker",false];
			_index = _vehicle AddEventHandler ["GetIn",{(_this Select 0) SetVariable["clearMarker",true]}];

			[_vehicle,_index] Spawn
			{
				Private["_index","_vehicle"];

				_vehicle = _this Select 0;
				_index = _this Select 1;

				_marker = Format["TempEmptyVehicleMarker%1",Random 1000];
				CreateMarkerLocal [_marker,Position _vehicle];
				_marker SetMarkerSizeLocal [1,1];
				_marker SetMarkerTextLocal Localize "STRWFEMPTY";
				_marker SetMarkerTypeLocal "Dot";
				_marker SetMarkerColorLocal "ColorWhite";

				While {!(_vehicle GetVariable "clearMarker")} do
				{
					Sleep 5;
					if (IsNull _vehicle) ExitWith {};
					if (GetDammage _vehicle >= 1) ExitWith {};
				};

				_vehicle RemoveEventHandler ["GetIn",_index];
				DeleteMarkerLocal _marker;
			};
		};

		_soldierName = Call Compile Format["%1SOLDIER",sideJoinedShortText];
		_crewName = Call Compile Format["%1CREW",sideJoinedShortText];
		_pilotName = Call Compile Format["%1PILOT",sideJoinedShortText];

		if (GetText (configFile >> "CfgVehicles" >> _unit >> "crew") == _crewName) then {_soldierName = _crewName};
		if (GetText (configFile >> "CfgVehicles" >> _unit >> "crew") == _pilotName) then {_soldierName = _pilotName};

		_driver = _team CreateUnit [_soldierName,GetPos _vehicle,[],0.2,"FORM"];
		[_driver] AllowGetIn true;
		_driver MoveInDriver _vehicle;
		[_driver,sideJoined] Call BIS_WF_InitUnit;

		if (_vehicle EmptyPositions "gunner" > 0) then
		{
			_gunner = _team CreateUnit [_soldierName,GetPos _vehicle,[],0.2,"FORM"];
			[_gunner] AllowGetIn true;
			_gunner MoveInGunner _vehicle;
			[_gunner,sideJoined] Call BIS_WF_InitUnit;
		};
		
		//Vilem: added commanders to vehicles
		if (_vehicle EmptyPositions "commander" > 0) then
		{
			_commander = _team CreateUnit [_soldierName,GetPos _vehicle,[],0.2,"FORM"];
			[_commander] AllowGetIn true;
			_commander MoveIncommander _vehicle;
			[_commander,_side] Call BIS_WF_InitUnit;
		};
	}
	else
	{
		_soldier = _team CreateUnit [_unit,_position,[],0.2,"FORM"];
		[_soldier,sideJoined] Call BIS_WF_InitUnit;
	};
}
else
{
	[CMDCREATEVEHICLE,_team,_vehicle,_factory] Exec (corePath + "Client\Client_CommandToServer.sqs");
};

//*****************************************************************************************
//3/28/7 MM - Created file.
