scriptName "Marta\data\scripts\fnc_getVisibleGroups.sqf";
/*
	File:fnc_getVisibleGroups.sqf
	Function: BIS_marta_getVisibleGroups (defined in marta fsm)
	Author: Vilem Benes - modified by Dimitri_Harkov for DIH_RADIO

	Description:
	Get groups visible in HC - take into account position and radius if given.

	Parameter(s):	
	_this select 0: position (optional) - position
	_this select 1: scalar (optional) - radius	
	
	Note: Marta is local, parameters for groups are set respective to player on given client
	Example: [player,position player, 10] call BIS_marta_getVisibleGroups;
*/
private ["_commander", "_position", "_radius", "_ret","_distanceCheck","_operator_side","_player_friendly_groups"];

/*
_distanceCheck = false;
if (count _this > 1) then
{
  _distanceCheck = true;
  _position = _this select 0;
  _radius = _this select 1;
};
*/

_ret = [];

_operator_side = playerside;

if (_operator_side == east) THEN 	{_player_friendly_groups = DIH_RADIO_fg_reports_names_e;};

if (_operator_side == west) THEN 	{_player_friendly_groups = DIH_RADIO_fg_reports_names_w;};

if (_operator_side == resistance) THEN 	{_player_friendly_groups = DIH_RADIO_fg_reports_names_r;};

if (_operator_side == civilian) THEN 	{_player_friendly_groups = DIH_RADIO_fg_reports_names_c;};

{
      if (isNull _x) then
      {              
      }
      else
      {
        _ret = _ret + [_x];
      };

} forEach (_player_friendly_groups);

//return all visible groups for player (in given radius from given position)
//debugLog format ["WFUI_CITY marta icons near %1 (<%2m) %3", _position, _radius, _ret];

if ((count hcallgroups player) < 1) THEN {_ret = [];};
	     
_ret