/*
DIH_RADIO_hc_checker.sqf by Dimitri_Harkov

1) wait a bit
2) if HC not running, stop script
3) else, start 5s loop
4) if player == hc commander -> re-enable MARTA locally, clear all DIH_RADIO markers
5) if player is no longer commadner -> disable MARTA again

*/

private ["_player", "_lgm_name", "_lgm_name_size", "_i"];

_player = _this select 0;


//--- 1)

waitUntil {(BIS_WF_CoreClientInitialized)};

//sleep 2.5;

BIS_WF_UpdateUnitMarker = Compile PreprocessFile ("DIH_radio\DIH_RADIO_Client_UpdateUnitMarker.sqf");
BIS_WF_CreateObjectMarkers = Compile PreprocessFile ("DIH_radio\DIH_RADIO_Client_CreateObjectMarkers.sqf");
BIS_marta_effect = compile preprocessFile ("DIH_radio\DIH_RADIO_fnc_marker_effect.sqf");
BIS_marta_getVisibleGroups  = compile preprocessFile ("DIH_radio\DIH_RADIO_fnc_getVisibleGroups.sqf");

//--- 2)

if (isNull BIS_HC_mainscope) exitWith {hint "no HC";};

//--- 3)

while {(true)} do
{

	//--- 4)

	if (((count hcallgroups player) > 0) AND (_player == player)) THEN
	{
		BIS_marta_mainscope setvariable ["minsize",1,false];
		BIS_marta_mainscope setvariable ["step",2,false];

		//DIH_RADIO_factions = ["USMC",-1,"INS",-1,"CDF",-1,"GUE",-1,"RU",-1,"CIV",-1,"CIV_RU",-1];

		for "_i" from 0 to (count DIH_RADIO_factions) step 2 do
		{
			if (faction player == (DIH_RADIO_factions select _i)) then
			{
				DIH_RADIO_factions set [_i+1,1];
			}
			ELSE
			{
				DIH_RADIO_factions set [_i+1,0];
			};
		};

		player setvariable ["MARTA_showRules",DIH_RADIO_factions];

		waitUntil {DIH_RADIO_updating == 0};

		for "_i" from 1 to DIH_RADIO_friend_count do
		{
			_lgm_name = format ["lgm_%1",str(_i)];
			_lgm_name_size = format ["lgm_size_%1",str(_i)];

			deleteMarkerLocal _lgm_name;
			deleteMarkerLocal _lgm_name_size;

		};

		DIH_RADIO_friend_count = 0;	
	}

	//--- 5)

	ELSE
	{
		for "_i" from 0 to (count DIH_RADIO_factions) step 2 do
		{
			DIH_RADIO_factions set [_i+1,-1];
		};

		player setvariable ["MARTA_showRules",DIH_RADIO_factions];

		BIS_marta_mainscope setvariable ["minsize",100,false];
		BIS_marta_mainscope setvariable ["step",2,false];
	};

	sleep 5;
};