//-----------------------------
//--- DIH_client_markers.sqf by Dimitri_Harkov
//-----------------------------------
//--- called by DIH_use_radio.sqf
//--- creates friendly group markers on all living human clients in formation with the radio operator


private ["_lgm_name", "_lgm_ptr", "_lgm_txt", "_i", "_player_friendly_groups", "_player_friendly_gr_pos", "_player_friendly_gr_type", "_player_friendly_gr_time", "_player_friendly_gr_wp", "_player_friendly_gr_size", "_cur_list_pos", "_date", "_l_alpha", "_operator"];


_operator = _this select 0;
_player_friendly_groups = _this select 1;
_player_friendly_gr_time = _this select 2;
_player_friendly_gr_pos = _this select 3;
_player_friendly_gr_type = _this select 4;
_player_friendly_gr_size = _this select 5;

_player_enemy_groups = _this select 6;
_player_enemy_gr_pos = _this select 7;
_player_enemy_gr_units = _this select 8;
_player_enemy_gr_time = _this select 9;


_date = [];
_cur_list_pos = 0;

_lgm_ptr="";
_lgm_name="";
_lgm_txt="";


	//--- Delete Markers from friendly contacts

	for "_i" from 1 to DIH_RADIO_friend_count do
	{
		_lgm_name = format ["lgm_%1",str(_i)];
		_lgm_name_size = format ["lgm_size_%1",str(_i)];

		deleteMarkerLocal _lgm_name;
		deleteMarkerLocal _lgm_name_size;
	};

	DIH_RADIO_friend_count = 0;


	//--- Delete Markers from enemy contacts

	for "_i" from 1 to DIH_RADIO_enemy_count do
	{
		_lgm_name = format ["lgm_e_%1",str(_i)];
		_lgm_name_size = format ["lgm_size_e_%1",str(_i)];

		deleteMarkerLocal _lgm_name;
		deleteMarkerLocal _lgm_name_size;
	};

	DIH_RADIO_enemy_count = 0;

{
	if (!(isNull _x) and (group _operator != _x)) THEN
	{

		//--- Quit forEach if current operator is HC commander. !!!TBD: what if hcallgroups is not defined?

		if ((count hcallgroups _operator) > 0) exitWith {};



		_cur_list_pos = ([_player_friendly_groups,_x] call BIS_fnc_arrayFindDeep) select 0;

		DIH_RADIO_friend_count = DIH_RADIO_friend_count + 1;

		_date = ([_player_friendly_gr_time select _cur_list_pos]) select 0;


		//--- group type marker

		_lgm_ptr = format ["lgm_ptr_%1",str(DIH_RADIO_friend_count)];
		_lgm_name = format ["lgm_%1",str(DIH_RADIO_friend_count)];

		_lgm_txt = format ["%1 (%2)", str(_x), [_date,"HH:MM"] call BIS_fnc_timeToString];

		_lgm_ptr = createMarkerLocal[_lgm_name, _player_friendly_gr_pos select _cur_list_pos];
		_lgm_ptr setMarkerShapeLocal "ICON";
		_lgm_name setMarkerTypeLocal (DIH_RADIO_marker_NATO_side + (_player_friendly_gr_type select _cur_list_pos));
		_lgm_name setMarkerColorLocal "ColorBlue";
		_lgm_name setMarkerTextLocal _lgm_txt;


		//--- calculate alpha, store faded markers for deletion.

		_l_alpha = if (((daytime) - (_date)) < 0) THEN
			{(100 - ((24+(daytime - _date))/(DIH_RADIO_marker_expire_time / 100)))/100}
			ELSE
			{(100 - ((daytime - _date)/(DIH_RADIO_marker_expire_time / 100)))/100};

		_lgm_name setMarkerAlphaLocal _l_alpha;


		//--- group size marker

		if ((_player_friendly_gr_size select _cur_list_pos) >= 1) THEN
		{

		_lgm_ptr_size = format ["lgm_ptr_size_%1",str(DIH_RADIO_friend_count)];
		_lgm_name_size = format ["lgm_size_%1",str(DIH_RADIO_friend_count)];
		_lgm_ptr_size = createMarkerLocal[_lgm_name_size, _player_friendly_gr_pos select _cur_list_pos];
		_lgm_ptr_size setMarkerShapeLocal "ICON";
		_lgm_name_size setMarkerTypeLocal ("group_" + str(_player_friendly_gr_size select _cur_list_pos));
		_lgm_name_size setMarkerColorLocal "ColorBlue";

		_lgm_name_size setMarkerAlphaLocal _l_alpha;

		};
	};
} forEach _player_friendly_groups;


{
	if (!(isNull (_x))) THEN
	{
		//--- Quit forEach if current operator is HC commander. !!!TBD: what if hcallgroups is not defined? !!!TBD: Needed for enemy markers?
		if ((count hcallgroups _operator) > 0) exitWith {};

		//--- store current index

		_cur_list_pos = ([_player_enemy_groups,(_x)] call BIS_fnc_arrayFindDeep) select 0;

		DIH_RADIO_enemy_count = DIH_RADIO_enemy_count + 1;

		_date = ([_player_enemy_gr_time select _cur_list_pos]) select 0;
		

		//--- group type marker

		_lgm_ptr = format ["lgm_ptr_e_%1",str(DIH_RADIO_enemy_count)];
		_lgm_name = format ["lgm_e_%1",str(DIH_RADIO_enemy_count)];

		_lgm_txt = format ["%1", [_date,"HH:MM"] call BIS_fnc_timeToString];

		_lgm_ptr = createMarkerLocal[_lgm_name, _player_enemy_gr_pos select _cur_list_pos];
		_lgm_ptr setMarkerShapeLocal "ICON";
		_lgm_name setMarkerTypeLocal (DIH_RADIO_marker_NATO_enemy +((_player_enemy_gr_units select _cur_list_pos) call DIH_RADIO_fnc_getType_special));
		//_lgm_name setMarkerTypeLocal "o_empty";
		_lgm_name setMarkerColorLocal "ColorRed";
		_lgm_name setMarkerTextLocal _lgm_txt;



		//--- calculate alpha, store faded markers for deletion.

		_l_alpha = if (((daytime) - (_date)) < 0) THEN
			{(100 - ((24+(daytime - _date))/(DIH_RADIO_marker_expire_time / 100)))/100}
			ELSE
			{(100 - ((daytime - _date)/(DIH_RADIO_marker_expire_time / 100)))/100};



		_lgm_name setMarkerAlphaLocal _l_alpha;


		//--- group size marker

		if ((count (_player_enemy_gr_units select _cur_list_pos)) > 0) THEN
		{

		_lgm_ptr_size = format ["lgm_ptr_size_e_%1",str(DIH_RADIO_enemy_count)];
		_lgm_name_size = format ["lgm_size_e_%1",str(DIH_RADIO_enemy_count)];
		_lgm_ptr_size = createMarkerLocal[_lgm_name_size, _player_enemy_gr_pos select _cur_list_pos];
		_lgm_ptr_size setMarkerShapeLocal "ICON";
		_lgm_name_size setMarkerTypeLocal ("group_" + str([(_player_enemy_groups select _cur_list_pos),(_player_enemy_gr_units select _cur_list_pos),((_player_enemy_gr_units select _cur_list_pos) call DIH_RADIO_fnc_getType_special)] call DIH_RADIO_fnc_getSize_special));
		_lgm_name_size setMarkerColorLocal "ColorRed";

		_lgm_name_size setMarkerAlphaLocal _l_alpha;

		};
	};
} forEach _player_enemy_groups;