/*
--- DIH Radio Init Scripts - by Dimitri Harkov
--- vb 0.5

--- to add:
--- radio in vehicle should by standard only be accessible from the inside. add special VehVar to allow it anyway in sp. cases - DONE
--- effective commanders should be allowed to use their vehicle radio too. - DONE
--- add possibility for on-board commander/commander radio too (MHQ models?) - SCRAPPED: can easily be done by some little scripts.
--- somehow also mark enemy contacts. It's hard to do this without the game becomeing to easy or exploitable
--- add option to mark friendly group waypoints. data is already stored in proper array
--- add option: only special characters may operate radios - ATM following people may operate radios: squad leaders may operate all radios,
---	vehicle commanders may use their vehicle's radio, infantry with radio may use their own radio.
--- auto-disable MARTA module if present - DONE, but the current 'solution' turns the commander's job into a very difficult one indeed...
--- auto-start the functions manager if it's not running already - DONE
--- standard AI Radio usage script - DONE
--- starting contact reports - these are not optional yet. - DONE
*/

private ["_BIS_marta_path", "_n", "_p", "_m", "_t", "_w", "_s", "_temp_type", "_temp_veh", "_temp_var", "_temp_cond", "_VarName", "_i", "_sc_ha"];


//-----------------------------------------------------
//INIT Functions Manager if not running already - Start
//-----------------------------------------------------

if (isnil "BIS_functions_mainscope") then
{
	if (isnil "DIH_Modules_grp") then {DIH_Modules_grp = createGroup sideLOGIC;};

	"LOGIC" createUnit [[0,0], DIH_Modules_grp,"BIS_functions_mainscope = this"];

	if (isServer) then
	{
		[BIS_functions_mainscope] execVM "ca\modules\functions\main.sqf";
	};
}
else
{
	BIS_functions_mainscope spawn
	{
		//debugLog format ["PRELOAD_ Functions\init  ERROR: deleting redundant FM! %1", [_this, (_this select 0), BIS_functions_mainscope]];
		_mygrp = group BIS_functions_mainscope;
		deleteVehicle BIS_functions_mainscope;
		deleteGroup _mygrp;
	};
};


if (isnil "RE") then {[] execVM "\ca\Modules\MP\data\scripts\MPframework.sqf";};

//-----------------------------------------------------
//INIT Functions Manager if nor running already - End
//-----------------------------------------------------

waituntil {!isnil "bis_fnc_init"};
//[] call BIS_fnc_help;

//-----------------------------------------------------
//Create DIH RAdio Module Logic if not running already - Start
//-----------------------------------------------------

if (isnil "DIH_Radio_mainscope") then
{
	if (isnil "DIH_Modules_grp") then {DIH_Modules_grp = createGroup sideLOGIC;};

	"LOGIC" createUnit [[0,0], DIH_Modules_grp,"DIH_Radio_mainscope = this"];
};

//-----------------------------------------------------
//Create DIH RAdio Module Logic if not running already - End
//-----------------------------------------------------


/*
if (isnil "bis_fnc_init") then {
	_logicFnc = (group _logic) createunit ["FunctionsManager",position player,[],0,"none"];
};
*/

//----------------------------
//DO NOT CHANGE THIS BLOCK!!!
//----------------------------
_BIS_marta_path = "ca\modules\marta\data\";
DIH_RADIO_fnc_getSize = compile preprocessFileLineNumbers (_BIS_marta_path + "scripts\fnc_getSize.sqf");
DIH_RADIO_fnc_getType = compile preprocessFileLineNumbers (_BIS_marta_path + "scripts\fnc_getType.sqf");

DIH_RADIO_fnc_getType_special = compile preprocessFile "DIH_radio\DIH_RADIO_fnc_getType_special.sqf";
DIH_RADIO_fnc_getSize_special = compile preprocessFile "DIH_radio\DIH_RADIO_fnc_getSize_special.sqf";

DIH_RADIO_fnc_getGroupPlayers = compile preprocessFile "DIH_radio\DIH_getGroupPlayers.sqf";
DIH_RADIO_fnc_groupChatToGroup = compile preprocessFile "DIH_radio\DIH_groupChatToGroup.sqf";
DIH_RADIO_fnc_groupChatSingle = compile preprocessFile "DIH_radio\DIH_groupChatSingle.sqf";
//DIH_RADIO_fnc_client_speech = compile preprocessFile "DIH_radio\DIH_RADIO_client_speech.sqf";

DIH_RADIO_AI_USE = compile preprocessFile "DIH_RADIO\DIH_RADIO_AI_radio_auto_use_standard.sqf";
DIH_RADIO_USE = compile preprocessFile "DIH_RADIO\DIH_use_radio.sqf";
DIH_RADIO_RESPAWN = compile preprocessFile "DIH_RADIO\DIH_RADIO_respawn.sqf";


/*
-----------------------------------------------------
--- DIH RADIO OPTIONS SECTION
-----------------------------------------------------
has been moved to external file for easier handling
*/

_sc_ha = execVM "DIH_radio\DIH_RADIO_settings.sqf";
waitUntil {scriptDone _sc_ha};

/*
DIH_RADIO_marker_NATO_side = "b_";		//(string) - what symbols to use for friendly troops b_ ... BLUFOR, o_ ... OPFOR, n_ ... neutral
DIH_RADIO_marker_NATO_enemy = "o_";		//(string) - as above for enemy troops

DIH_RADIO_marker_expire_time = 0.13;		//(number) - 1 = 1 hour; when the limit has been reached, markes have faded and group is considered destroyed and will be removed from the marker list.

DIH_RADIO_transmission_time = 15;		//(number) - time it takes to complete radio transmission

DIH_RADIO_cable_length = 3;			//(number) - max distance between operator and radio man. Better not change this.
DIH_RADIO_veh_diam_const = 4;			//(number) - this distance will be added to the cable length when using vehicle radios from the outside. Necessary because distance is measured from the center of the vehicle.

DIH_RADIO_channels_max_ewgc = [6,6,6,6];	//(array) - max number of people that can communicate with the HQ at once (east west guer civ)
DIH_RADIO_channels_cur_ewgc = [0,0,0,0];	//(array) - current number of people that communicate with the HQ (east west guer civ)

DIH_RADIO_factions = ["USMC",-1,"INS",-1,"CDF",-1,"GUE",-1,"RU",-1,"CIV",-1,"CIV_RU",-1];	//(array) - all factions that are in the mission need to be listed here, followed by -1

//use the two arrays below to define custom sounds for each faction. make sure that corresponding entries use the same index pos in each array.

DIH_RADIO_speech_faction_name =		["USMC",		"INS",			"CDF",			"RU",			"GUE",			"CIV",			"CIV_RU"		];
DIH_RADIO_speech_faction_sound =	["DIH_reportinginEN",	"DIH_reportinginRU",	"DIH_reportinginCZ",	"DIH_reportinginRU",	"DIH_reportinginCZ",	"DIH_reportinginCZ",	"DIH_reportinginRU"	];

DIH_RADIO_auto_add_on = true;			//(BOOLEAN) - if set to true, auto adds radios to starting units. see the following x vars for rules
DIH_RADIO_auto_add_white = ["tank","air","helicopter"];			//(array) - whitelist of all vehicle classes that do get radios - this adds radios to all derived classes as well. e.g. "landVehicles" would add radios to all tanks, cars, ... "car"
DIH_RADIO_auto_add_black = [];			//(array) - blacklist of all vehicle classes that never get radios - beware of contradictions, in which case he blacklist has precedence
DIH_RADIO_auto_add_white_cond = "(false)";	//(string) - all infantry units where this condition is true will get a radio, unless their kind is on the blacklist;
//_x stands for the unit in question. Default value is "false"; examples:
//"leader _x == _x"				--> all squad leaders have radios
//"(leader _x == _x) AND (vehicle _x == _x)"	--> all infantry squad leaders have radios
//""PortableR168Radio" in weapons _x"	--> everyone with a portable R168 Radio gets the radio ability (NOTE: This nice piece of equipment does not exist yet)

DIH_RADIO_AI_radio_auto_use_standard = true;			//(BOOLEAN) - if set to true, standard AI script for radio operators will be activated.

DIH_RADIO_starting_contacts = true;				//(BOOLEAN) - if set to true, all groups that are on the map at game start have updated their positions to their commander (i.e: You always see at least all starting positions of your friendly groups when you use a radio for the first time in a mission) - disable in warfare!
DIH_RADIO_auto_mark_starting_contacts = true;				//(BOOLEAN) - if set to true, all contacts will automatically be marked on each players map on game start.

DIH_RADIO_respawnDelay = 15;			//(number) - should be the same as respawnDelay in description.ext

DIH_RADIO_warfare_adjustments_on = false;				//(BOOLEAN) - if set to true, some standard warfare Functions will be replaced with adjusted ones that auto-add radios to vehicles that have been bought an fullfill the white/blacklist requirements. Also, respawned soldiers with radios will keep their radio ability.  You can turn this feature off, as it might interfere with customized warfare modes.

DIH_RADIO_enemy_detection_range = 1000;		//(number) - enemy contacts up to this distance to operator are reported - has serious performance impact, I guess

DIH_RADIO_radio_list_check_toggle = true;		//(BOOLEAN) - if set to true, the radio man has to have one of the listed items below for a transmission
DIH_RADIO_radio_list = ["ItemRadio"];		//(item or weapon classname(s)) - the radio man has to have one of the listed items for a transmission - IMPORTANT: lower/upper case DO matter!
*/

/*
Special vehicle vars - use the with 'setVariable':

DIH_RADIO_present		//used by the auto-add radio function and the AI radio usage function. Tells them who has a radio (1 = yes)
DIH_RADIO_inuse			//used by the use_radio.sqf function. do not set manually
DIH_RADIO_external_radio	//set this to 1 for vehicles that have radios that can be accesses from the outside of the vehicle too
*/


//----------------------------_
//DO NOT CHANGE ANYTHING BELOW!
//----------------------------_

//---
if (isServer) THEN
{
	DIH_Radio_mainscope setVariable ["DIH_RADIO_channels_max", DIH_RADIO_channels_max_ewgc, true];
	DIH_Radio_mainscope setVariable ["DIH_RADIO_channels_cur", DIH_RADIO_channels_cur_ewgc, true];

	DIH_Radio_mainscope setVariable ["DIH_RADIO_eg_reports_east", [[grpNull],[[0, 0, 0]],[[objNull]],[0],[]], true];
	DIH_Radio_mainscope setVariable ["DIH_RADIO_eg_reports_west", [[grpNull],[[0, 0, 0]],[[objNull]],[0],[]], true];
	DIH_Radio_mainscope setVariable ["DIH_RADIO_eg_reports_guer", [[grpNull],[[0, 0, 0]],[[objNull]],[0],[]], true];
	DIH_Radio_mainscope setVariable ["DIH_RADIO_eg_reports_civ", [[grpNull],[[0, 0, 0]],[[objNull]],[0],[]], true];
};

DIH_RADIO_friend_count = 0;			//(number) - don't change! counts the number of markers that have been added on each client - NEVER PUBLIC THIS VARIABLE
DIH_RADIO_enemy_count = 0;			//(number) - same as above for enemies
DIH_RADIO_abort_transmission = false;		//(BOOLEAN) - don't change! used locally to interupt radio transmissions - NEVER PUBLIC THIS VARIABLE
DIH_RADIO_updating = 0;				//(number) - don't change! is 1 when a use_radio.sqf manipulates the global variables.


//-----------------------------------------------------------------
//--- both Server and Clients:
//---	- auto-add radios
//-----------------------------------------------------------------


//--- Auto-Add Radios part

if ((DIH_RADIO_auto_add_on) AND (true)) THEN
{
	{
		_temp_veh = _x;
		_temp_type = typeOf _x;

		//--- check whitelist

		{
			if ((_temp_type isKindOf _x)) THEN
			{
				_temp_var = _temp_veh getVariable "DIH_RADIO_present";
				if (isNil ("_temp_var")) THEN {_temp_veh setVariable ["DIH_RADIO_present", 0, false];};
				if ((_temp_veh getVariable "DIH_RADIO_present") == 0) THEN
				{
					_temp_id = _temp_veh addAction ["Use Radio", "DIH_radio\DIH_RADIO_action.sqf",[],-9,false,true,"",""];
					//_temp_id = _temp_veh addAction ["Use Radio", DIH_RADIO_USE,[],-9,false,true,"",""];

					_temp_veh setVariable ["DIH_RADIO_present", 1, false];
				};
			};
		} forEach DIH_RADIO_auto_add_white;

		//--- check blacklist

		{
			if ((_temp_type isKindOf _x)) THEN
			{
				_temp_var = _temp_veh getVariable "DIH_RADIO_present";
				if (isNil ("_temp_var")) exitWith {};
				if ((_temp_veh getVariable "DIH_RADIO_present") == 1) THEN
				{
					_temp_veh removeAction _temp_id;
					_temp_veh setVariable ["DIH_RADIO_present", 0, false];
				};
			};
		} forEach DIH_RADIO_auto_add_black;

	} forEach vehicles;

	{
		_temp_veh = _x;
		_temp_type = typeOf _x;

		//--- check special add condition

		_temp_cond = false;
		call compile format ["_temp_cond = (%1)", DIH_RADIO_auto_add_white_cond];

		if (_temp_cond) THEN
		{
			_temp_var = _temp_veh getVariable "DIH_RADIO_present";
			if (isNil ("_temp_var")) THEN {_temp_veh setVariable ["DIH_RADIO_present", 0, false];};
			if ((_temp_veh getVariable "DIH_RADIO_present") == 0) THEN
			{
				_temp_id = _temp_veh addAction ["Use Radio", "DIH_radio\DIH_RADIO_action.sqf",[],-10,false,true,"",""];
				//_temp_id = _temp_veh addAction ["Use Radio", DIH_RADIO_USE,[],-10,false,true,"",""];

				_temp_veh setVariable ["DIH_RADIO_present", 1, false];
			};
		};

		//--- check whitelist

		{
			if ((_temp_type isKindOf _x)) THEN
			{
				_temp_var = _temp_veh getVariable "DIH_RADIO_present";
				if (isNil ("_temp_var")) THEN {_temp_veh setVariable ["DIH_RADIO_present", 0, false];};
				if ((_temp_veh getVariable "DIH_RADIO_present") == 0) THEN
				{
					_temp_id = _temp_veh addAction ["Use Radio", "DIH_radio\DIH_RADIO_action.sqf",[],-10,false,true,"",""];
					//_temp_id = _temp_veh addAction ["Use Radio", DIH_RADIO_USE,[],-10,false,true,"",""];

					_temp_veh setVariable ["DIH_RADIO_present", 1, false];
				};
			};
		} forEach DIH_RADIO_auto_add_white;

		//--- check blacklist

		{
			if ((_temp_type isKindOf _x)) THEN
			{
				_temp_var = _temp_veh getVariable "DIH_RADIO_present";
				if (isNil ("_temp_var")) exitWith {};
				if ((_temp_veh getVariable "DIH_RADIO_present") == 1) THEN
				{
					_temp_veh removeAction _temp_id;
					_temp_veh setVariable ["DIH_RADIO_present", 0, false];
				};
			};
		} forEach DIH_RADIO_auto_add_black;

	} forEach allUnits;
};


//-----------------------------------------------------------------
//--- Server only:
//--- init arrays
//--- + optional:
//---	- starting contact reports
//-----------------------------------------------------------------


if (isServer) THEN {


//--------------------------
//--- Disable MARTA
//---  Note: there is a special script for each player that re-enables Marta for HC commanders
//--------------------------

if (!(isnil 'BIS_marta_mainscope')) then {BIS_marta_mainscope setvariable ["minsize",100,true];};
if (!(isnil 'BIS_marta_mainscope')) then {BIS_marta_mainscope setvariable ["step",2,true];};


//--------------------------
//--- Default AI Radio usage
//--------------------------


if (DIH_RADIO_AI_radio_auto_use_standard) THEN
{
	{
		{
			//--- add all units with radios. skip each squad as soon as one with radio has been found

			if ((_x getVariable "DIH_RADIO_present") == 1) THEN
			{
				//[_x] execVM "DIH_RADIO\DIH_RADIO_AI_radio_auto_use_standard.sqf";
				[_x] spawn DIH_RADIO_AI_USE;
				if (true) exitWith {};				
			};

			//--- add unit leaders in vehicles, if their vehicle has a radio. skip each squad as soon as one has been found

			if ((leader _x == _x) AND (vehicle _x != _x) AND (((vehicle _x) getVariable "DIH_RADIO_present") == 1)) THEN
			{
				//[_x] execVM "DIH_RADIO\DIH_RADIO_AI_radio_auto_use_standard.sqf";
				[_x] spawn DIH_RADIO_AI_USE;
				if (true) exitWith {};				
			};
		} forEach units _x;
	} forEach allGroups;
};


//--------------------------
//--- Starting Contacts
//--------------------------

//--- East starting friendly contact reports

_n			= [grpNull];
_p			= [[0, 0, 0]];
_m			= [""];
_t			= [0];
_w			= [[0, 0, 0]];
_s			= [0];

{
	if (!(DIH_RADIO_starting_contacts)) exitWith {DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_east", [count _n,_n,_p,_m,_t,_w,_s,[]], true];};

	if (side _x == east) THEN
	{

	_n = _n			+ [_x];
	_p = _p			+ [getPos leader _x];
	_m = _m			+ [(_x call DIH_RADIO_fnc_getType)];
	_t = _t			+ [daytime];
	_w = _w			+ [getWPPos [_x,currentWaypoint _x]];
	_s = _s			+ [[_x,units _x,_m Select (Count _n - 1)] call DIH_RADIO_fnc_getSize];

	};

} forEach AllGroups;

DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_east", [count _n,_n,_p,_m,_t,_w,_s,[]], true];

/* was:
DIH_RADIO_fg_reports_total_e = count _n;
DIH_RADIO_fg_reports_names_e = _n;
DIH_RADIO_fg_reports_pos_e = _p;
DIH_RADIO_fg_reports_type_e = _m;
DIH_RADIO_fg_reports_time_e = _t;
DIH_RADIO_fg_reports_waypoint_e = _w;
DIH_RADIO_fg_reports_size_e = _s;
DIH_RADIO_fg_reports_empty_e = [];
*/

//--- West starting friendly contact reports

_n			= [grpNull];
_p			= [[0, 0, 0]];
_m			= [""];
_t			= [0];
_w			= [[0, 0, 0]];
_s			= [0];

{
	if (!(DIH_RADIO_starting_contacts)) exitWith {DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_west", [count _n,_n,_p,_m,_t,_w,_s,[]], true];};

	if (side _x == west) THEN
	{

	_n = _n			+ [_x];
	_p = _p			+ [getPos leader _x];
	_m = _m			+ [(_x call DIH_RADIO_fnc_getType)];
	_t = _t			+ [daytime];
	_w = _w			+ [getWPPos [_x,currentWaypoint _x]];
	_s = _s			+ [[_x,units _x,_m Select (Count _n - 1)] call DIH_RADIO_fnc_getSize];

	};

} forEach AllGroups;

DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_west", [count _n,_n,_p,_m,_t,_w,_s,[]], true];

/* was
DIH_RADIO_fg_reports_total_w = count _n;
DIH_RADIO_fg_reports_names_w = _n;
DIH_RADIO_fg_reports_pos_w = _p;
DIH_RADIO_fg_reports_type_w = _m;
DIH_RADIO_fg_reports_time_w = _t;
DIH_RADIO_fg_reports_waypoint_w = _w;
DIH_RADIO_fg_reports_size_w = _s;
DIH_RADIO_fg_reports_empty_w = [];
*/


//--- Guer starting friendly contact reports

_n			= [grpNull];
_p			= [[0, 0, 0]];
_m			= [""];
_t			= [0];
_w			= [[0, 0, 0]];
_s			= [0];

{
	if (!(DIH_RADIO_starting_contacts)) exitWith {DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_guer", [count _n,_n,_p,_m,_t,_w,_s,[]], true];};

	if (side _x == resistance) THEN
	{

	_n = _n			+ [_x];
	_p = _p			+ [getPos leader _x];
	_m = _m			+ [(_x call DIH_RADIO_fnc_getType)];
	_t = _t			+ [daytime];
	_w = _w			+ [getWPPos [_x,currentWaypoint _x]];
	_s = _s			+ [[_x,units _x,_m Select (Count _n - 1)] call DIH_RADIO_fnc_getSize];

	};

} forEach AllGroups;

DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_guer", [count _n,_n,_p,_m,_t,_w,_s,[]], true];

/* was
DIH_RADIO_fg_reports_total_g = count _n;
DIH_RADIO_fg_reports_names_g = _n;
DIH_RADIO_fg_reports_pos_g = _p;
DIH_RADIO_fg_reports_type_g = _m;
DIH_RADIO_fg_reports_time_g = _t;
DIH_RADIO_fg_reports_waypoint_g = _w;
DIH_RADIO_fg_reports_size_g = _s;
DIH_RADIO_fg_reports_empty_g = [];
*/


//--- Civ starting friendly contact reports

_n			= [grpNull];
_p			= [[0, 0, 0]];
_m			= [""];
_t			= [0];
_w			= [[0, 0, 0]];
_s			= [0];

{
	if (!(DIH_RADIO_starting_contacts)) exitWith {DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_civ", [count _n,_n,_p,_m,_t,_w,_s,[]], true];};

	if (side _x == civilian) THEN
	{

	_n = _n			+ [_x];
	_p = _p			+ [getPos leader _x];
	_m = _m			+ [(_x call DIH_RADIO_fnc_getType)];
	_t = _t			+ [daytime];
	_w = _w			+ [getWPPos [_x,currentWaypoint _x]];
	_s = _s			+ [[_x,units _x,_m Select (Count _n - 1)] call DIH_RADIO_fnc_getSize];

	};

} forEach AllGroups;

DIH_Radio_mainscope setVariable ["DIH_RADIO_fg_reports_civ", [count _n,_n,_p,_m,_t,_w,_s,[]], true];

/* was
DIH_RADIO_fg_reports_total_c = count _n;
DIH_RADIO_fg_reports_names_c = _n;
DIH_RADIO_fg_reports_pos_c = _p;
DIH_RADIO_fg_reports_type_c = _m;
DIH_RADIO_fg_reports_time_c = _t;
DIH_RADIO_fg_reports_waypoint_c = _w;
DIH_RADIO_fg_reports_size_c = _s;
DIH_RADIO_fg_reports_empty_c = [];
*/


//--- public these variables

/* was
publicVariable "DIH_RADIO_fg_reports_total_e";
publicVariable "DIH_RADIO_fg_reports_names_e";
publicVariable "DIH_RADIO_fg_reports_pos_e";
publicVariable "DIH_RADIO_fg_reports_type_e";
publicVariable "DIH_RADIO_fg_reports_time_e";
publicVariable "DIH_RADIO_fg_reports_waypoint_e";
publicVariable "DIH_RADIO_fg_reports_size_e";
publicVariable "DIH_RADIO_fg_reports_empty_e";

publicVariable "DIH_RADIO_fg_reports_total_w";
publicVariable "DIH_RADIO_fg_reports_names_w";
publicVariable "DIH_RADIO_fg_reports_pos_w";
publicVariable "DIH_RADIO_fg_reports_type_w";
publicVariable "DIH_RADIO_fg_reports_time_w";
publicVariable "DIH_RADIO_fg_reports_waypoint_w";
publicVariable "DIH_RADIO_fg_reports_size_w";
publicVariable "DIH_RADIO_fg_reports_empty_w";

publicVariable "DIH_RADIO_fg_reports_total_r";
publicVariable "DIH_RADIO_fg_reports_names_r";
publicVariable "DIH_RADIO_fg_reports_pos_r";
publicVariable "DIH_RADIO_fg_reports_type_r";
publicVariable "DIH_RADIO_fg_reports_time_r";
publicVariable "DIH_RADIO_fg_reports_waypoint_r";
publicVariable "DIH_RADIO_fg_reports_size_r";
publicVariable "DIH_RADIO_fg_reports_empty_r";

publicVariable "DIH_RADIO_fg_reports_total_c";
publicVariable "DIH_RADIO_fg_reports_names_c";
publicVariable "DIH_RADIO_fg_reports_pos_c";
publicVariable "DIH_RADIO_fg_reports_type_c";
publicVariable "DIH_RADIO_fg_reports_time_c";
publicVariable "DIH_RADIO_fg_reports_waypoint_c";
publicVariable "DIH_RADIO_fg_reports_size_c";
publicVariable "DIH_RADIO_fg_reports_empty_c";
*/

//!!!TBD: use setVariable in that case too!
//DIH_RADIO_init = true;
//publicVariable "DIH_RADIO_init";

DIH_Radio_mainscope setVariable ["DIH_RADIO_init", true, true];

};



//-----------------------------------------------------------------
//---	- auto-mark starting contacts (local players only)
//-----------------------------------------------------------------


//waitUntil {(DIH_RADIO_init)};

if ((DIH_RADIO_auto_mark_starting_contacts) AND (local player)) THEN
{
	[player] execVM "DIH_radio\DIH_RADIO_initial_client_markers.sqf";
	//hint "!";
};

//-----------------------------------------------------------------
//---	- HC commander detection script (local players only)
//-----------------------------------------------------------------

if (local player) THEN
{	
	[player] execVM "DIH_radio\DIH_RADIO_hc_checker.sqf";
};

//-----------------------------------------------------------------
//---	- WF / MARTA replacement functions (local players only)
//-----------------------------------------------------------------

/*
if (local player) THEN
{
BIS_WF_UpdateUnitMarker = Compile PreprocessFile ("DIH_radio\DIH_RADIO_Client_UpdateUnitMarker.sqf");
BIS_WF_CreateObjectMarkers = Compile PreprocessFile ("DIH_radio\DIH_RADIO_Client_CreateObjectMarkers.sqf");
BIS_marta_effect = compile preprocessFile ("DIH_radio\DIH_RADIO_fnc_marker_effect.sqf");
BIS_marta_getVisibleGroups  = compile preprocessFile ("DIH_radio\DIH_RADIO_fnc_getVisibleGroups.sqf");
};
*/

//BIS_marta_effect = compile preprocessFileLineNumbers ("DIH_radio\DIH_RADIO_fnc_marker_effect.sqf");

sleep 3;
//hint "!";

if (DIH_RADIO_warfare_adjustments_on) THEN
{
BIS_WF_BuyClientUnit = Compile PreprocessFile "DIH_radio\DIH_RADIO_Client_BuyUnit.sqf";
BIS_WF_BuyServerUnit = Compile PreprocessFile "DIH_radio\DIH_RADIO_Server_BuyUnit.sqf";
BIS_WF_PlayerRespawn = Compile PreprocessFile "DIH_radio\DIH_RADIO_Client_PlayerRespawn.sqf";
BIS_WF_TeamUpdateRespawn = Compile PreprocessFile "DIH_radio\DIH_RADIO_Team_UpdateRespawn.sqf";
};


//--- auto renaming & addition of event handlers

_i = 0;

{
	IF (vehicleVarName _x == "") THEN 
	{
		_VarName= Format ["an_%1",_i];
		_x SetVehicleVarName _VarName;
		_x Call Compile Format ["%1=_This ; PublicVariable ""%1""",_VarName];

		_i=_i+1;
	};
} forEach allUnits;

{
	if ((true) and ((_x getVariable "DIH_RADIO_present") == 1)) THEN

	//(local _x) and 

	{
		_x addEventHandler ["killed", {[_this select 0] spawn DIH_RADIO_RESPAWN}];
	};
} forEach allUnits;


//--- return 'true'

true